<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: griddata.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
<h1>griddata.h</h1><a href="griddata_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">/* $Id: griddata.h 3014 2010-03-26 17:27:32Z scholz $ */</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="preprocessor">#ifdef PYTHON</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span><span class="preprocessor">#include &quot;Python.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#endif</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#ifndef GRIDDATA_H</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#define GRIDDATA_H</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="comment">/* define variable __FUNCT__ (used by MagparFunction below)</span>
<a name="l00034"></a>00034 <span class="comment">   need to do before including petsc headers</span>
<a name="l00035"></a>00035 <span class="comment">   otherwise cpp complains about it being redefined here</span>
<a name="l00036"></a>00036 <span class="comment">*/</span>
<a name="l00037"></a>00037 <span class="preprocessor">#ifdef __GNUC__</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#define __FUNCT__ __FUNCTION__</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span><span class="preprocessor">#elif __STDC_VERSION__ == 199901L</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">#define __FUNCT__ __FUNC__</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00042"></a><a class="code" href="griddata_8h.html#ae60511a9aa5cbf216a00a1bb81006bc5">00042</a> <span class="preprocessor"></span><span class="preprocessor">#define __FUNCT__ &quot;function&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;petscsys.h&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &quot;petscts.h&quot;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &quot;petscao.h&quot;</span>
<a name="l00048"></a>00048 
<a name="l00050"></a>00050 <span class="preprocessor">#ifdef TAO</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#include &quot;tao.h&quot;</span>
<a name="l00052"></a>00052 <span class="preprocessor">#endif</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>
<a name="l00054"></a>00054 <span class="comment">/* check PETSc and TAO versions:</span>
<a name="l00055"></a>00055 <span class="comment">magpar requires</span>
<a name="l00056"></a>00056 <span class="comment">(PETSc version 3.0.0 and TAO ???) or</span>
<a name="l00057"></a>00057 <span class="comment">(PETSc version 2.3.3 and TAO 1.9)</span>
<a name="l00058"></a>00058 <span class="comment">*/</span>
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 <span class="preprocessor">#if (PETSC_VERSION_MAJOR == 3 &amp;&amp; PETSC_VERSION_MINOR == 1 &amp;&amp; PETSC_VERSION_SUBMINOR == 0)</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span><span class="preprocessor">#define PETSC_VERSION 310</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span><span class="preprocessor">#elif (PETSC_VERSION_MAJOR == 3 &amp;&amp; PETSC_VERSION_MINOR == 0 &amp;&amp; PETSC_VERSION_SUBMINOR == 0)</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span><span class="preprocessor">#define PETSC_VERSION 300</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span><span class="preprocessor">#elif (PETSC_VERSION_MAJOR == 2 &amp;&amp; PETSC_VERSION_MINOR == 3 &amp;&amp; PETSC_VERSION_SUBMINOR == 3)</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span><span class="preprocessor">#define PETSC_VERSION 233</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span><span class="preprocessor">#ifdef TAO</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span><span class="preprocessor">#if (TAO_VERSION_MAJOR != 1 &amp;&amp; TAO_VERSION_MINOR != 8 &amp;&amp; TAO_VERSION_SUBMINOR != 3)</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span><span class="preprocessor">#error PETSc version 2.3.3 requires TAO version 1.9</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span><span class="preprocessor">#error &quot;PETSc version unsupported or unknown! Please use one of the supported versions!&quot;</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span>
<a name="l00075"></a><a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">00075</a> <span class="preprocessor">#define MagparFunctionLogBegin        int ierr;PetscLogDouble t_t1,t_t2;{PetscFunctionBegin;PetscPrintf(PETSC_COMM_WORLD,&quot;\n&gt;&gt; %s::%s\n&quot;,__FILE__,__FUNCT__);PetscInfo2(0,&quot;%s%s&quot;,Id,Td);PetscGetTime(&amp;t_t1);ierr=0;}</span>
<a name="l00076"></a><a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">00076</a> <span class="preprocessor"></span><span class="preprocessor">#define MagparFunctionLogReturn(A)   {PetscGetTime(&amp;t_t2);PetscPrintf(PETSC_COMM_WORLD,&quot;&lt;&lt; %s::%s took %g s\n\n&quot;,__FILE__,__FUNCT__,t_t2-t_t1);CHKMEMQ;PetscFunctionReturn(A);}</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span><span class="preprocessor">#if PETSC_VERSION &gt;= 232</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span><span class="preprocessor">#define MagparFunctionInfoBegin       int ierr;PetscLogDouble t_t1,t_t2;{PetscFunctionBegin;PetscInfo1(0,&quot;%s\n&quot;,__FILE__);PetscInfo2(0,&quot;%s%s&quot;,Id,Td);PetscGetTime(&amp;t_t1);ierr=0;}</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span><span class="preprocessor">#define MagparFunctionInfoReturn(A)  {PetscGetTime(&amp;t_t2);PetscInfo1(0,&quot;took %g s\n\n&quot;,t_t2-t_t1);PetscFunctionReturn(A);}</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span><span class="preprocessor">#define MagparFunctionProfReturn(A)  {PetscGetTime(&amp;t_t2);PetscTruth profile;PetscOptionsHasName(PETSC_NULL,&quot;-profile&quot;,&amp;profile);if (profile) {PetscPrintf(PETSC_COMM_WORLD,&quot;%s::%s took %g s\n&quot;,__FILE__,__FUNCT__,t_t2-t_t1);} else {PetscInfo1(0,&quot;took %g s\n&quot;,t_t2-t_t1);} PetscFunctionReturn(A);}</span>
<a name="l00081"></a>00081 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00082"></a><a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">00082</a> <span class="preprocessor"></span><span class="preprocessor">#define MagparFunctionInfoBegin       int ierr;PetscLogDouble t_t1,t_t2;{PetscFunctionBegin;PetscGetTime(&amp;t_t1);ierr=0;}</span>
<a name="l00083"></a><a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">00083</a> <span class="preprocessor"></span><span class="preprocessor">#define MagparFunctionInfoReturn(A)  {PetscGetTime(&amp;t_t2);PetscFunctionReturn(A);}</span>
<a name="l00084"></a><a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">00084</a> <span class="preprocessor"></span><span class="preprocessor">#define MagparFunctionProfReturn(A)  {PetscGetTime(&amp;t_t2);PetscFunctionReturn(A);}</span>
<a name="l00085"></a>00085 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>
<a name="l00088"></a>00088 <span class="preprocessor">#include &lt;assert.h&gt;</span>
<a name="l00089"></a>00089 
<a name="l00093"></a><a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">00093</a> <span class="preprocessor">#define ND 3       </span>
<a name="l00094"></a><a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">00094</a> <span class="preprocessor">#define NV 4       </span>
<a name="l00095"></a><a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">00095</a> <span class="preprocessor">#define NF 4       </span>
<a name="l00096"></a><a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">00096</a> <span class="preprocessor">#define NN 3       </span>
<a name="l00097"></a><a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">00097</a> <span class="preprocessor">#define NP 19      </span>
<a name="l00099"></a>00099 <span class="preprocessor"></span>
<a name="l00100"></a>00100 <span class="preprocessor"></span>
<a name="l00104"></a><a class="code" href="griddata_8h.html#ae002d636437ba3349f6501c36cfb5e02">00104</a> <span class="preprocessor">#define C_BND -1   </span>
<a name="l00105"></a><a class="code" href="griddata_8h.html#af23ac2ffd709eb569a1f0c98d06be299">00105</a> <span class="preprocessor">#define C_INT -2   </span>
<a name="l00106"></a><a class="code" href="griddata_8h.html#a23a3109d94031a21452ba531f1544898">00106</a> <span class="preprocessor">#define C_UNK -4   </span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>
<a name="l00109"></a><a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">00109</a> <span class="preprocessor"></span><span class="preprocessor">#define D_EPS PETSC_MACHINE_EPSILON*100 </span>
<a name="l00114"></a><a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">00114</a> <span class="preprocessor">#define MU0 (12.566371e-7) </span>
<a name="l00115"></a><a class="code" href="griddata_8h.html#a8659b9de3e544ff142b153b076f30fd5">00115</a> <span class="preprocessor">#define GAMMA (2.210173e5) </span>
<a name="l00117"></a>00117 <span class="preprocessor"></span>
<a name="l00118"></a>00118 <span class="preprocessor"></span><span class="comment">/* value of damping constant for which M is locked/rigid */</span>
<a name="l00119"></a><a class="code" href="griddata_8h.html#a8a54558688c833b1f886703d3012f1dd">00119</a> <span class="preprocessor">#define RIGID_M_ALPHA 999</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span>
<a name="l00121"></a>00121 <span class="comment">/* replace all calls to cblas with simple macros here</span>
<a name="l00122"></a>00122 <span class="comment">   because we are just coping with ND=3 vectors</span>
<a name="l00123"></a>00123 <span class="comment">   thus, big overhead for calling real cblas functions!</span>
<a name="l00124"></a>00124 <span class="comment">*/</span>
<a name="l00125"></a>00125 
<a name="l00126"></a><a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">00126</a> <span class="preprocessor">#define my_daxpy(a,b,c,d,e,f) {(e)[0]+=b*(c)[0];(e)[1]+=b*(c)[1];(e)[2]+=b*(c)[2];}</span>
<a name="l00127"></a><a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">00127</a> <span class="preprocessor"></span><span class="preprocessor">#define my_dcopy(a,b,c,d,e)   {(d)[0]=(b)[0];(d)[1]=(b)[1];(d)[2]=(b)[2];}</span>
<a name="l00128"></a><a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">00128</a> <span class="preprocessor"></span><span class="preprocessor">#define my_dnrm2(a,b,c)       sqrt((b)[0]*(b)[0]+(b)[1]*(b)[1]+(b)[2]*(b)[2])</span>
<a name="l00129"></a><a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">00129</a> <span class="preprocessor"></span><span class="preprocessor">#define my_dscal(a,b,c,d)     {(c)[0]*=b;(c)[1]*=b;(c)[2]*=b;}</span>
<a name="l00130"></a><a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">00130</a> <span class="preprocessor"></span><span class="preprocessor">#define my_ddot(a,b,c,d,e)    ((b)[0]*(d)[0]+(b)[1]*(d)[1]+(b)[2]*(d)[2])</span>
<a name="l00131"></a><a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">00131</a> <span class="preprocessor"></span><span class="preprocessor">#define douter(a,b,c,d)       {(d)[0]=(b)[1]*(c)[2]-(b)[2]*(c)[1];(d)[1]=(b)[2]*(c)[0]-(b)[0]*(c)[2];(d)[2]=(b)[0]*(c)[1]-(b)[1]*(c)[0];}</span>
<a name="l00132"></a>00132 <span class="preprocessor"></span>
<a name="l00136"></a>00136 <span class="preprocessor">#if PETSC_VERSION &lt;= 220</span>
<a name="l00137"></a><a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14">00137</a> <span class="preprocessor"></span><span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>;
<a name="l00138"></a><a class="code" href="griddata_8h.html#a32a4e1dd07864f1ebecfd23654aff9c8">00138</a> <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="griddata_8h.html#a32a4e1dd07864f1ebecfd23654aff9c8">PetscBLASInt</a>;
<a name="l00139"></a>00139 <span class="preprocessor">#endif</span>
<a name="l00140"></a>00140 <span class="preprocessor"></span>
<a name="l00141"></a><a class="code" href="structGridData.html">00141</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>{
<a name="l00142"></a><a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">00142</a>   <span class="keywordtype">char</span>      simname[256]; 
<a name="l00143"></a><a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">00143</a>   <span class="keywordtype">int</span>       inp;          
<a name="l00145"></a><a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">00145</a>   PetscReal time;         
<a name="l00147"></a><a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">00147</a>   <span class="keywordtype">int</span>       mode;         
<a name="l00149"></a><a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">00149</a>   PetscReal hscale;       
<a name="l00150"></a><a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">00150</a>   PetscReal tscale;       
<a name="l00151"></a><a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">00151</a>   PetscReal escale;       
<a name="l00152"></a><a class="code" href="structGridData.html#a462c4e47756448bdd7578c61697deb6c">00152</a>   PetscReal lenscale;     
<a name="l00155"></a>00155   <span class="comment">/* ************************************************************************</span>
<a name="l00156"></a>00156 <span class="comment">     other variables</span>
<a name="l00157"></a>00157 <span class="comment">  */</span>
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="comment">/* mesh data */</span>
<a name="l00160"></a>00160 
<a name="l00164"></a><a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">00164</a>   <span class="keywordtype">int</span> n_vert;     
<a name="l00165"></a><a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">00165</a>   <span class="keywordtype">int</span> n_ele;      
<a name="l00167"></a>00167 
<a name="l00171"></a><a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">00171</a>   <span class="keywordtype">int</span> ln_vert;    
<a name="l00172"></a><a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">00172</a>   <span class="keywordtype">int</span> ln_ele;     
<a name="l00174"></a>00174 
<a name="l00178"></a><a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">00178</a>   PetscReal *vertxyz;      
<a name="l00179"></a><a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">00179</a>   <span class="keywordtype">int</span>       *vertl2g;      
<a name="l00180"></a><a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">00180</a>   <span class="keywordtype">int</span>       *vertnewproc;  
<a name="l00181"></a><a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">00181</a>   Vec       vertvol;       
<a name="l00182"></a><a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">00182</a>   <span class="keywordtype">int</span>       *vertprop;     
<a name="l00184"></a>00184 
<a name="l00188"></a><a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">00188</a>   <span class="keywordtype">int</span>       *elevert;    
<a name="l00189"></a><a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">00189</a>   <span class="keywordtype">int</span>       *eleprop;    
<a name="l00190"></a><a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">00190</a>   <span class="keywordtype">int</span>       *elel2g;     
<a name="l00191"></a><a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">00191</a>   <span class="keywordtype">int</span>       *elenewproc; 
<a name="l00192"></a><a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">00192</a>   Vec       elevol;      
<a name="l00193"></a><a class="code" href="structGridData.html#a221b259fa149eef6f0982c2b6c9629f2">00193</a>   PetscReal elenmax;     
<a name="l00194"></a><a class="code" href="griddata_8h.html#afa7ccbed0d85816fdd68f17ae0a98418">00194</a> <span class="preprocessor">#define HAVE_ELEVERTALL</span>
<a name="l00195"></a>00195 <span class="preprocessor"></span><span class="preprocessor">#ifdef HAVE_ELEVERTALL</span>
<a name="l00196"></a>00196 <span class="preprocessor"></span>  <span class="keywordtype">int</span>       *elevertall; 
<a name="l00197"></a>00197 <span class="preprocessor">#define HAVE_M2IJ</span>
<a name="l00198"></a>00198 <span class="preprocessor"></span><span class="preprocessor">#ifdef HAVE_M2IJ</span>
<a name="l00199"></a>00199 <span class="preprocessor"></span>  <span class="keywordtype">int</span>       *mesh2nodal_ia;
<a name="l00200"></a>00200   <span class="keywordtype">int</span>       *mesh2nodal_ja;
<a name="l00201"></a>00201   <span class="keywordtype">int</span>       *mesh2dual_ia;
<a name="l00202"></a>00202   <span class="keywordtype">int</span>       *mesh2dual_ja;
<a name="l00203"></a>00203 <span class="preprocessor">#endif</span>
<a name="l00204"></a>00204 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00205"></a>00205 <span class="preprocessor"></span>
<a name="l00210"></a><a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">00210</a>   <span class="keywordtype">int</span>       n_vert_bnd;    
<a name="l00211"></a><a class="code" href="structGridData.html#a0d57327dd6a657273e24613f3edd7fce">00211</a>   <span class="keywordtype">int</span>       n_bnd_fac;     
<a name="l00212"></a><a class="code" href="structGridData.html#af59cf93f7a91c270b9f07c2bf2453e25">00212</a>   <span class="keywordtype">int</span>       ln_bnd_fac;    
<a name="l00213"></a><a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">00213</a>   <span class="keywordtype">int</span>       *vertbndg2bnd; 
<a name="l00214"></a><a class="code" href="structGridData.html#a018ce7264f478c6eae964c4a753a796b">00214</a>   <span class="keywordtype">int</span>       *bndfacvert;   
<a name="l00216"></a>00216 
<a name="l00220"></a><a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">00220</a>   <span class="keywordtype">int</span>       n_prop; 
<a name="l00221"></a><a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">00221</a>   PetscReal *propdat; 
<a name="l00241"></a>00241 
<a name="l00242"></a>00242 <span class="comment">/* ************************************************************************** */</span>
<a name="l00243"></a>00243 
<a name="l00247"></a><a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">00247</a>   Vec       M;          
<a name="l00248"></a><a class="code" href="structGridData.html#a776aed135c71061b20ec61cdbb39604d">00248</a>   Vec       VHdem;      
<a name="l00249"></a><a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">00249</a>   Vec       VMs3;       
<a name="l00250"></a><a class="code" href="structGridData.html#a93b54f2f6a796c1528054e5b91977287">00250</a>   PetscReal Edem;       
<a name="l00251"></a><a class="code" href="structGridData.html#a17f878ef23cf508f086e5d1958657e3f">00251</a>   Vec       VHexchani;  
<a name="l00252"></a><a class="code" href="structGridData.html#accc6d5863bfdcbf0dde4e412350729b1">00252</a>   PetscReal Eexchani;   
<a name="l00253"></a>00253 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00254"></a>00254 <span class="preprocessor"></span>  Vec       VHexchonly; 
<a name="l00255"></a>00255   PetscReal Eexchonly;  
<a name="l00256"></a>00256 <span class="preprocessor">#endif</span>
<a name="l00257"></a><a class="code" href="structGridData.html#a9fdfeb31eb70dd07c65f5717feddcdbf">00257</a> <span class="preprocessor"></span>  Vec       VHext;      
<a name="l00258"></a><a class="code" href="structGridData.html#a17b4a3f0a4fcf4832fe0004f242a4ecb">00258</a>   PetscReal Eext;       
<a name="l00259"></a><a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">00259</a>   Vec       VHtot;      
<a name="l00260"></a><a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">00260</a>   PetscReal Etot;       
<a name="l00262"></a>00262 
<a name="l00263"></a><a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">00263</a>   PetscReal totvol;     
<a name="l00264"></a><a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">00264</a>   <span class="keywordtype">int</span>       equil;      
<a name="l00265"></a><a class="code" href="structGridData.html#ad44d2e83b58c9fc6b13f7fb3258bc323">00265</a>   PetscReal vequil;     
<a name="l00267"></a>00267 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00268"></a>00268 <span class="preprocessor"></span><span class="preprocessor">#include &quot;addons/griddatadd.h&quot;</span>
<a name="l00269"></a>00269 <span class="preprocessor">#endif</span>
<a name="l00270"></a>00270 <span class="preprocessor"></span>
<a name="l00271"></a>00271 <span class="preprocessor">#ifdef SPINTORQ</span>
<a name="l00272"></a>00272 <span class="preprocessor"></span><span class="preprocessor">#include &quot;spintorq/griddatadd.h&quot;</span>
<a name="l00273"></a>00273 <span class="preprocessor">#endif</span>
<a name="l00274"></a>00274 <span class="preprocessor"></span>
<a name="l00275"></a>00275 <span class="preprocessor">#ifdef EBM</span>
<a name="l00276"></a>00276 <span class="preprocessor"></span><span class="preprocessor">#include &quot;ebm/griddata_ebm.h&quot;</span>
<a name="l00277"></a>00277 <span class="preprocessor">#endif</span>
<a name="l00278"></a>00278 <span class="preprocessor"></span>
<a name="l00279"></a>00279 <span class="preprocessor">#ifdef PYTHON</span>
<a name="l00280"></a>00280 <span class="preprocessor"></span><span class="preprocessor">#define MAGPARSTDPYTHONMOD &quot;magpar_std_mod&quot;</span>
<a name="l00281"></a>00281 <span class="preprocessor"></span>  PyObject *pModule;
<a name="l00282"></a>00282 <span class="preprocessor">#endif</span>
<a name="l00283"></a>00283 <span class="preprocessor"></span>
<a name="l00284"></a>00284 } <a class="code" href="structGridData.html">GridData</a>;
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 <span class="preprocessor">#endif</span>
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

